#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){
	ofBackground(60,60,70);
	tex.allocate(320, 240, GL_RGB);
	pixelsLoaded = false;
}

//--------------------------------------------------------------
void testApp::update(){
	client.update(2048);
	
	if( client.getState() == COMPLETE ){
		tex.loadData(client.pixels, 320, 240, GL_RGB);
		pixelsLoaded = true;
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	string statusStr =  "status: " + client.getStateStr();
	statusStr += " -- loaded "+ofToString(client.getPctLoaded(), 2)+"%";
	
	ofSetColor(255, 0, 255);
	ofDrawBitmapString(statusStr, 10, 20);
	ofDrawBitmapString("client - launch server than hit c key to connect - r to reset the state", 10, ofGetHeight()-20);
	
	ofSetColor(255, 255, 255);
	if( pixelsLoaded ){
		tex.draw(0, 25);
	}
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){
    if( key == 'c'){
		client.setup("127.0.0.1", 44999);
	}
	if(key == 'r'){
		client.reset();
	}
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
   
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
    
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
